nucleiImage0 = imread('cells2.jpg');
nucleiImage = rgb2gray(nucleiImage0);
threshImage = nucleiImage >40;
%edgeImage = edge(threshImage, 'canny');
edgeImage = edge(threshImage, 'sobel');
%edgeImage = edge(threshImage, 'prewitt');
labeledImage = bwlabel(threshImage);
figure(1);
subplot(2, 2, 1);imagesc(nucleiImage);
subplot(2, 2, 2);imagesc(threshImage);
subplot(2, 2, 3);imagesc(edgeImage);
subplot(2, 2, 4);imagesc(labeledImage);


stats = regionprops(labeledImage,'Centroid', 'Area');
edges = find(edgeImage ~= 0);
nucleiImage(edges) = 255;

figure(2);
imshow(nucleiImage);
for i =1:length(stats)
text(stats(i).Centroid(1), stats(i).Centroid(2),...
num2str(i), 'Color',[1, 1, 0], 'FontSize', 14,...
'HorizontalAlignment', 'center');
end;
